#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		debug_package	%{nil}
%define		sname		%(echo %{name} | cut -d '-' -f2)
#-----------------------------------------------------------------------------
Name		:	qt6-qtquick3d
Version		:	6.8.0
Release		:	17.2.0.rel%{?dist}
Summary		:	Qt6 - Quick3D Libraries and utilities

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://download.qt.io/archive/qt/(vers/rel)/sumodules

Source0		:	%{sname}-everywhere-src-%{version}.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	:	cmake
BuildRequires	:	gcc-c++
BuildRequires	:	qt6-qtbase-devel		= %{version}
BuildRequires	:	qt6-qtdeclarative-devel		= %{version}
BuildRequires	:	qt6-qtdeclarative-static	= %{version}
BuildRequires	:	qt6-qtquicktimeline-devel	= %{version}
BuildRequires	:	qt6-qtshadertools-devel		= %{version}
BuildRequires	:	Vulkan-Loader-devel

#-----------------------------------------------------------------------------
%description
The Qt 6 Quick3D library.
 
#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%license LICENSES/GPL*
%{_qt6_libdir}/libQt6Quick3D.so.6*
%{_qt6_libdir}/libQt6Quick3DAssetImport.so.6*
%{_qt6_libdir}/libQt6Quick3DRuntimeRender.so.6*
%{_qt6_libdir}/libQt6Quick3DUtils.so.6*
%{_qt6_libdir}/libQt6Quick3DIblBaker.so.6*
%{_qt6_libdir}/libQt6Quick3DParticles.so.6*
%{_qt6_libdir}/libQt6Quick3DAssetUtils.so.6*
%{_qt6_libdir}/libQt6Quick3DEffects.so.6*
%{_qt6_libdir}/libQt6Quick3DHelpers.so.6*
%{_qt6_libdir}/libQt6Quick3DHelpersImpl.so*
%{_qt6_libdir}/libQt6Quick3DParticleEffects.so.6*
%{_qt6_libdir}/libQt6Quick3DGlslParser.so.6*
%{_qt6_libdir}/libQt6Quick3DXr.so.6*
%{_qt6_qmldir}/QtQuick3D/
%{_qt6_plugindir}/assetimporters/*.so

#=============================================================================
%package		devel
Summary		:	Development files for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}				= %{version}
Requires	:	qt6-qtbase-devel		= %{version}
Requires	:	qt6-qtdeclarative-devel		= %{version}
Requires	:	qt6-qtdeclarative-static	= %{version}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries and
header files for developing applications that
use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_bindir}/balsam-qt6
%{_bindir}/meshdebug-qt6
%{_bindir}/shadergen-qt6
%{_bindir}/balsamui-qt6
%{_bindir}/instancer-qt6
%{_bindir}/materialeditor-qt6
%{_bindir}/shapegen-qt6
%{_qt6_bindir}/balsam
%{_qt6_bindir}/meshdebug
%{_qt6_bindir}/shadergen
%{_qt6_bindir}/balsamui
%{_qt6_bindir}/instancer
%{_qt6_bindir}/materialeditor
%{_qt6_bindir}/shapegen
%{_qt6_archdatadir}/mkspecs/modules/*.pri
%{_qt6_libdir}/qt6/modules/*.json
%{_qt6_includedir}/QtQuick3D/
%{_qt6_includedir}/QtQuick3DAssetImport/
%{_qt6_includedir}/QtQuick3DIblBaker/
%{_qt6_includedir}/QtQuick3DParticles/
%{_qt6_includedir}/QtQuick3DRuntimeRender/
%{_qt6_includedir}/QtQuick3DUtils/
%{_qt6_includedir}/QtQuick3DAssetUtils/
%{_qt6_includedir}/QtQuick3DHelpers/
%{_qt6_includedir}/QtQuick3DHelpersImpl/
%{_qt6_includedir}/QtQuick3DGlslParser/
%{_qt6_includedir}/QtQuick3DXr/
%{_qt6_includedir}/QtOpenXR/
%{_qt6_libdir}/libQt6BundledEmbree.a
%{_qt6_libdir}/libQt6BundledOpenXR.a
%{_qt6_libdir}/cmake/Qt6/FindWrapBundledOpenXRConfigExtra.cmake
%{_qt6_libdir}/cmake/Qt6/FindWrapBundledEmbreeConfigExtra.cmake
%{_qt6_libdir}/cmake/Qt6/FindWrapOpenXR.cmake
%{_qt6_libdir}/cmake/Qt6/FindWrapSystemOpenXR.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DParticles/*.cmake
%{_qt6_libdir}/cmake/Qt6/FindWrapQuick3DAssimp.cmake
%{_qt6_libdir}/cmake/Qt6BuildInternals/StandaloneTests/*.cmake
%{_qt6_libdir}/cmake/Qt6Qml/*.cmake
%{_qt6_libdir}/cmake/Qt6Qml/QmlPlugins/*.cmake
%{_qt6_libdir}/cmake/Qt6BundledEmbree/*.cmake
%{_qt6_libdir}/cmake/Qt6BundledOpenXR/Qt6BundledOpenXR*.cmake
%{_qt6_libdir}/cmake/Qt6OpenXRPrivate/Qt6OpenXRPrivate*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3D/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DAssetImport/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DRuntimeRender/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DTools/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DUtils/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DAssetUtils/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DEffects/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DHelpers/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DHelpersImpl/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DGlslParserPrivate/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DIblBaker/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DParticleEffects/*.cmake
%{_qt6_libdir}/cmake/Qt6Quick3DXr/Qt6Quick3DXr*.cmake
%{_qt6_libdir}/libQt6Quick3D.prl
%{_qt6_libdir}/libQt6Quick3D.so
%{_qt6_libdir}/libQt6Quick3DAssetImport.prl
%{_qt6_libdir}/libQt6Quick3DAssetImport.so
%{_qt6_libdir}/libQt6Quick3DRuntimeRender.prl
%{_qt6_libdir}/libQt6Quick3DRuntimeRender.so
%{_qt6_libdir}/libQt6Quick3DUtils.prl
%{_qt6_libdir}/libQt6Quick3DUtils.so
%{_qt6_libdir}/libQt6Quick3DIblBaker.prl
%{_qt6_libdir}/libQt6Quick3DIblBaker.so
%{_qt6_libdir}/libQt6Quick3DParticles.prl
%{_qt6_libdir}/libQt6Quick3DParticles.so
%{_qt6_libdir}/libQt6Quick3DAssetUtils.prl
%{_qt6_libdir}/libQt6Quick3DAssetUtils.so
%{_qt6_libdir}/libQt6Quick3DEffects.prl
%{_qt6_libdir}/libQt6Quick3DEffects.so
%{_qt6_libdir}/libQt6Quick3DHelpers.prl
%{_qt6_libdir}/libQt6Quick3DHelpers.so
%{_qt6_libdir}/libQt6Quick3DHelpersImpl.prl
%{_qt6_libdir}/libQt6Quick3DHelpersImpl.so
%{_qt6_libdir}/libQt6Quick3DGlslParser.prl
%{_qt6_libdir}/libQt6Quick3DGlslParser.so
%{_qt6_libdir}/libQt6Quick3DParticleEffects.prl
%{_qt6_libdir}/libQt6Quick3DParticleEffects.so
%{_qt6_libdir}/libQt6Quick3DXr.prl
%{_qt6_libdir}/libQt6Quick3DXr.so
%{_qt6_libdir}/qt6/metatypes/qt6*_metatypes.json
%{_qt6_plugindir}/qmltooling/libqmldbg_quick3dprofiler.so
%{_qt6_libdir}/pkgconfig/*.pc

#=============================================================================
%package		examples
Summary		:	Example files for %{name}


#-----------------------------------------------------------------------------
%description		examples
Example files for %{name}

#-----------------------------------------------------------------------------
%files			examples
%defattr(-,root,root,-)
%{_qt6_examplesdir}/

#=============================================================================
%prep
%setup -q -n %{sname}-everywhere-src-%{version}

#-----------------------------------------------------------------------------
#building application
%build

	
cmake							\
	-B _bld						\
	-G Ninja					\
	-S .						\
	-D CMAKE_MESSAGE_LOG_LEVEL=STATUS		\
	-D INSTALL_TRANSLATIONSDIR=%{_qt6_translationdir} \
	-D INSTALL_DATADIR=%{_qt6_datadir}		\
	-D INSTALL_ARCHDATADIR=%{_qt6_archdatadir}	\
	-D INSTALL_PLUGINSDIR=%{_qt6_plugindir}		\
	-D INSTALL_EXAMPLESDIR=%{_qt6_examplesdir}	\
	-D QT_BUILD_EXAMPLES_BY_DEFAULT=ON		\
	-D QT_INSTALL_EXAMPLES_SOURCES=ON		\
	
cmake							\
	--build						\
	_bld						\
	--parallel %(/usr/bin/getconf _NPROCESSORS_ONLN)\


#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	cmake						\
	--install					\
	_bld

%{__mkdir_p} %{buildroot}%{_bindir}

pushd %{buildroot}%{_qt6_bindir}
for i in * ; do
  case "${i}" in
    balsam|meshdebug|shadergen|balsamui|instancer|materialeditor|shapegen)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt6
      ;;
    *)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ;;
  esac
done

#-----------------------------------------------------------------------------
%changelog
